<template>
  <div>
    <el-page-header
      :content="detailsId?'编辑':'新增'"
      style=" padding: 20px 20px 0 20px;"
      @back="handleBack"
    />
    <sales-header ref="header" />
    <sales-table :data-list="dataList" :column="column" is-operation is-selection @handleSelection="handleSelection">
      <template #bts>
        <div>
          <el-button type="primary" size="mini" @click="dialogVisible=true">添加</el-button>
          <el-button type="danger" size="mini" @click="delChange">删除</el-button>
        </div>
      </template>
      <template #events>
        <div v-if="!detailsId">
          <el-button type="primary" size="mini" @click="handelSubmit(1)">提交</el-button>
          <el-button size="mini">重置</el-button>
          <el-button size="mini" :disabled="dis" @click="handleInform(2)">通知发货</el-button>
        </div>
        <div v-else>
          <el-button type="primary" size="mini" @click="handelSubmit(2)">保存</el-button>
          <el-button size="mini">重置</el-button>
        </div>
      </template>
      <template v-slot:custom="{item:{row,$index}}">
        <el-radio v-model="row.flag" label="1">增加</el-radio>
        <el-radio v-model="row.flag" label="-1">减少</el-radio>
      </template>
      <template v-slot:operation="{item:{row,$index}}">
        <el-popconfirm
          style="margin-left: 10px"
          title="删除？"
          @confirm="handleDel(row,$index)"
        >
          <el-button slot="reference" type="text" size="mini">删除</el-button>
        </el-popconfirm>
      </template>
    </sales-table>
    <sales-dialog
      :data-list="dataList"
      :dialog-visible="dialogVisible"
      :customer-number="customerNumber"
      :func="getDialogList"
      @confirm="confirm"
    />
  </div>
</template>

<script>
import SalesDialog from '@/components/SalesDialog/SalesDialog'
import SalesHeader from '@/components/SalesHeader/SalesHeader'
import SalesTable from '@/components/SalesTable/SalesTable'
import { addFrontOrder, getFrontOrderDetail, sbumitFrontOrder, updateFrontOrder } from '@/api/sales'
import { getcustomerFrontList } from '@/api/stock'

export default {
  name: 'WarehouseForm',
  components: {
    SalesHeader,
    SalesTable,
    SalesDialog
  },
  props: ['detailsId', 'pageType'],
  data() {
    return {
      dialogVisible: false,
      customerNumber: '',
      dataList: [],
      selection: [],
      disabled: false,
      flag: 1,
      dis: true,
      column: [
        {
          prop: 'materialName',
          label: '产品名称',
          width: '180'
        },
        {
          prop: 'materialOldNumber',
          label: '物料编码',
          width: '180'
        },
        {
          prop: 'specification',
          label: '规格型号',
          width: '300'
        },
        {
          prop: 'stockLockQty',
          label: '库存数量',
          width: '180'
        },
        {
          prop: 'qty',
          label: '数量',
          width: '180',
          isInput: true
        },
        {
          prop: 'volume',
          label: '体积',
          width: '180'
        },
        {
          prop: 'totalVolume',
          label: '总体积',
          width: '180'
        },
        {
          prop: 'notes',
          label: '备注',
          width: '180',
          isInput: true,
          type: 'text'

        }
      ]
    }
  },
  created() {
    if (this.detailsId) {
      getFrontOrderDetail({ id: this.detailsId }).then(res => {
        this.dataList = res.data.orders
        this.$refs.header.screenForm = res.data
        this.$refs.header.screenForm.disabled = this.disabled = res.data.status !== 1

        this.$refs.header.screenForm.provinceId = res.data.province
        this.$refs.header.screenForm.cityId = res.data.city
        this.$refs.header.screenForm.areaId = res.data.area
        this.$refs.header.screenForm.streetId = res.data.street
        this.$refs.header.screenForm.stockType = res.data.stockType == 1 ? '前置仓' : '商家仓'
      })
    } else {
      Object.assign(this.$data, this.$options.data())
    }
  },
  methods: {

    getDialogList(p) {
      return getcustomerFrontList(...p)
    },
    confirm(selected) {
      console.log(selected)
      this.dataList = selected
      this.$refs.header.screenForm.customerName = this.dataList[0].customerName
      this.$refs.header.screenForm.customerNumber = this.dataList[0].customerNumber
      this.$refs.header.screenForm.stockType = this.dataList[0].stockType
      this.customerNumber = this.dataList[0].customerNumber
      this.dialogVisible = false
    },
    handleDel(item, index) {
      this.dataList.splice(index, 1)
      if (!this.dataList.length) {
        this.$nextTick(() => {
          this.$refs.header.screenForm = {}
          this.customerNumber = ''
        })
      }
    },
    delChange() {
      this.dataList.forEach((k, i) => {
        this.selection.forEach((l, e) => {
          if (k.id === l.id) {
            this.dataList.splice(i, 1)
            this.selection.splice(e, 1)
          }
        })
      })
      if (!this.dataList.length) {
        this.$nextTick(() => {
          this.$refs.header.screenForm = {}
          this.customerNumber = ''
        })
      }
    },
    handleSelection(data) {
      this.selection = data
    },
    handleInform(status = 2) {
      console.log(33)
      sbumitFrontOrder({ id: this.$refs.header.screenForm.id, status }).then(res => {
        console.log(res)
      })
    },
    handelSubmit(type, status = 1) {
      if (!this.dataList.length) {
        this.$errorMsg('请添加产品')
        return
      }
      for (let i = 0; i < this.dataList.length; i++) {
        this.dataList[i].id = ''
        this.dataList[i].directFlag = this.dataList[i].flag
        console.log(Number(this.dataList[i].qty))

        if (Number(this.dataList[i].qty) < 0 || !this.dataList[i].qty) {
          this.$errorMsg(`第${i + 1}产品数量有误`)
          return
        }
      }

      const params = {
        ...this.$refs.header.screenForm,
        orders: this.dataList,
        status: status
      }
      if (type == 1) {
        params.id = ''
        addFrontOrder(params).then(res => {
          this.$successMsg('新增成功')
          this.dis = false
          // this.pageType = 0

          this.$forceUpdate()
        })
      } else {
        updateFrontOrder(params).then(res => {
          this.$successMsg('编辑成功')
          this.handleBack()
          this.$forceUpdate()
        })
      }
    },
    handleBack() {
      this.$emit('close')
    }

  }
}
</script>

<style scoped>

</style>
